package javaapplication1;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JTextArea;
import javax.swing.SwingUtilities;

/**
 *
 * @author andreas
 */
public class JTextAreaWorkingThread implements Runnable {

    //Referencia al JTextArea

    private JTextArea jTextArea;

    //Esta clase no tiene razón de ser si no tenemos un... JTextArea!

    public JTextAreaWorkingThread(JTextArea jTextArea) {
        this.jTextArea = jTextArea;
    }
    
    //Este m&eacute;todo escribe la l&iacute;nea en el JTextArea
    private void writeLine(final String line) {
        //Ejecutar en el hilo de despacho de eventos del AWT
        SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
                jTextArea.append(line);
            }
        });
    }

    @Override
    public void run() {
        //Obtiene el separador de l&iacute;nea del OS
        final String lineSeparator = System.getProperty("line.separator");
        //La l&iacute;nea a escribir
        String line = null;
        //Repetimos 100 veces
        for (int i = 0; i < 100; i++) {
            //Construimos la l&iacute;nea 
            line = "Esta es la línea: " + i + " " + lineSeparator;
            //Escribimos la l&iacute;nea
            this.writeLine(line);
            //Dormimos un ratito
            try {
                Thread.sleep(1000);
            } catch (InterruptedException ex) {
                Logger.getLogger(JTextAreaWorkingThread.class.getName()).log(Level.SEVERE, null, ex);
            }

        }
    }

}
